#include "ti86asm.inc"

.org _asm_exec_ram

	call _homeup		;put cursor at top left
	call _clrScrn		;clear screen

	ld a,$12		;$12 - program
				;$0c - string
	ld hl,$bfff		;absolute start of vat
				;the routine automatically
				; swaps in ram page 7 (the
				; vatiable allocation table)
				; so this is a valid address
loop:
		push bc		;save loop counter
	call vatsrch		;search starting at hl for program
	jp c,exit_two		;carry set tells us there was
				; an error or it reached the end
				; of the vat
		push hl		;save where we ended
		push af		;save the type we're searching for
	ld de,_OP1		;where we want to store
				; name at
	call copy_to_op1	;copy backwards vat name to
				; op1 the right way
	ex de,hl		;we need it in hl so we
				; can display it
	call _putps		;display length indexed string
				; at hl
	call _homeup		;put cursor at top left
	call _getkey		;wait for keypress
	cp kExit
	jr z,exit
	call _clrScrn
		pop af		;get back type searching for
		pop hl		;get back where we left off
		pop bc		;get back loop counter
	djnz loop


	jp _clrScrn		;clear screen and quit
exit:
		pop af		;get off type
		pop af		;get off address
exit_two:
		pop af		;get off loop counter
	jp _clrScrn

#include "vatsrch.inc"		;the include file with all the
				; vat routines used:
				;  - vatsrch
				;  - copy_to_op1
.end